import bpy
import os

from . import icons
from . import constants

def menu_func(self, context):
    layout = self.layout
    pcoll = icons.thomas_icons["thomas_legacy"]
    custom_icon = pcoll["Thomas Rig Legacy"].icon_id

    preferenes = context.preferences.addons[constants.PACKAGE].preferences 
    loaded = preferenes.mc_textures_loaded
    ignore = preferenes.mc_textures_ignore
    if loaded or ignore:
        layout.operator("view3d.thomasriglegacyappend", icon_value = custom_icon)
    else:
        layout.alert = True
        layout.operator("thomasriglegacy.mc_textures_import", icon_value = custom_icon)

class OBJECT_MT_APPEND(bpy.types.Operator):
    bl_idname = "view3d.thomasriglegacyappend"
    bl_label = "Thomas Rig Legacy"

    def execute(self, context):
        blendfile = os.path.join(constants.RIGS_PATH, "Thomas Rig Legacy.blend")
        section = "Collection"
        obj = "Rig [only append this]"
        filepath  = os.path.join(blendfile,section,obj)
        directory = os.path.join(blendfile,section)
        filename  = obj
        bpy.ops.wm.append(filepath=filepath,filename=filename,directory=directory,link=False,active_collection=False)

        # select the rig
        rig = context.selected_objects[0]
        context.view_layer.objects.active = rig
        return{'FINISHED'}


#━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━
#                   (un)register
#━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━━
          
def register():
    bpy.utils.register_class(OBJECT_MT_APPEND)
    bpy.types.VIEW3D_MT_add.append(menu_func)
  
def unregister():
    bpy.types.VIEW3D_MT_add.remove(menu_func)
    bpy.utils.unregister_class(OBJECT_MT_APPEND)